Still needs some error handling, but here's the basic procedure.
I'll be updating the forum as I update this procedure.

I had originally planned to use the nLocked field to gaurentee locking of the 
record, however with 6.5 row locking I've held off 'till I get this nailed down.

The ID Table

CREATE TABLE Id (
       cKeyName             char(20) NOT NULL,
       cValue               varchar(10) NOT NULL DEFAULT '         1',
       nLocked              tinyint NULL
)

ALTER TABLE Id
       ADD  PRIMARY KEY (cKeyName)
go



if exists (select * from sysobjects where id = object_id('dbo.sp_NewId') and sysstat & 0xf = 4)
	drop procedure dbo.sp_NewId
GO

CREATE PROCEDURE sp_NewId
@tcTable VARCHAR(30),
@tcNewId VARCHAR(10) = '' OUTPUT
AS

/*
  Procedure.........: sp_NewId
  Author............: Steven Lasker
  Project...........: Tec Data Load
  Created...........: May 12 '96
  Copyright.........: (c) The Entertainment Connection, 1996
  Description.......: This is an adaptation of the NewId procedure used in
                      Visual FoxPro CodeBook 3 by Yair Alan Griver
                      and Flash Creative Management, Inc.
                      Changes are as follows:
                        Only UPPER case letters are used.  Since most sites
                        make use of the ability for SQL Server to treat a and A
                        as the same.  It also skips some anoying characters that 
                        can confuse us humans, such as 0 and O, 1 and l.
  Calling Samples...: sp_NewId '<Table Name>', @lcNewId OUTPUT
  Parameter List....: @tcTable  The name of the table to search for in the ID table
                      @tcNewId  The return parameter for the new Id
  Major change list.: 
  Index.............: ID_PK
*/
DECLARE @lnIdLength INT,
        @lcValue    VARCHAR(10),
        @lnDigit    INT,
        @lnChar     INT,
        @lcNewId    VARCHAR(10),
        @lcChar     CHAR(1)

-- Set-up some defaults
SELECT @lcNewId = ""

-- First mark it locked during execution of the next ID
UPDATE ID
   SET nLocked = 1
 WHERE cKeyName = @tcTable


-- Get the last value from the ID Table
SELECT @lcValue = cValue
  FROM ID
 WHERE cKeyName = @tcTable


-- How long is the field
SELECT @lnIdLength = DATALENGTH(@lcValue)


-- Set up a counter
SELECT @lnDigit = @lnIdLength

WHILE @lnDigit > 0
BEGIN
  SELECT @lnChar = ASCII(SUBSTRING(@lcValue, @lnDigit, 1))

  IF @lnChar = 90 -- ASCII value of Z
  BEGIN
    SELECT @lcValue = SUBSTRING(@lcValue, 1, @lnDigit -1) + 
                      '2' +
                      RIGHT(@lcValue, @lnIdLength - @lnDigit)
  END
  ELSE
  BEGIN
    SELECT @lcChar =
           CASE 
             WHEN @lnChar = 57 -- ASCII value of 9
               THEN 'A'
             WHEN @lnChar = 32 -- ASCII value of <SPACE>
               THEN '2'
             WHEN @lnChar = 72 -- ASCII value of H
               -- this provides us a way of skipping L's
               THEN 'J'
             WHEN @lnChar = 75 -- ASCII value of K
               -- this provides us a way of skipping L's
               THEN 'M'
             WHEN @lnChar = 78 -- ASCII value of N
               -- this provides us a way of skipping O's and zeros
               THEN 'P'
             ELSE CHAR(@lnChar +1)
           END -- CASE


    SELECT @lcNewId = SUBSTRING(@lcValue, 1, @lnDigit -1 ) +
                      @lcChar + 
                      RIGHT(@lcValue, @lnIdLength - @lnDigit)

    BREAK
  END

  -- Decrement the counter digit so it moves one character to the left
  SELECT @lnDigit = @lnDigit -1

END --WHILE @lnDigit > 1

UPDATE ID
   SET nLocked  = 0,
       cValue   = @lcNewId
 WHERE cKeyName = @tcTable

SELECT @tcNewId = @lcNewId 

Error:
  RETURN
GO

